<template>
  <div>
    <b-row align-h="center">
      <b-col sm="12" md="6" lg="5" class="my-1">
        <b-form-group
          label="Filter"
          label-for="filter-input"
          label-cols-sm="3"
          label-align-sm="right"
          label-size="sm"
          class="mb-0"
        >
          <b-input-group size="sm">
            <b-form-input
              id="filter-input"
              v-model="filter.search"
              type="search"
              placeholder="Buscar por nombre,codigo,gestion"
            ></b-form-input>

            <b-input-group-append>
              <b-button @click="searchOrShortOrPage()">Buscar</b-button>
            </b-input-group-append>
          </b-input-group>
        </b-form-group>
      </b-col>
    </b-row>

    <!-- Main table element -->
      <!-- :per-page="filter.perPage" -->
    <b-table
      :key="keyTable"
      :items="items"
      :fields="fields"
      :current-page="filter.currentPage"
      :filter="filter.filter"
      stacked="md"
      show-empty
      small
      :outlined="true"
    >
      <template #cell(acciones)="row">
        <b-button
          v-if="row.item.acciones.mostrar.show"
          size="sm"
          :variant="row.item.acciones.mostrar.color"
          class="mr-1"
          @click="mostarItem(row.item.id)"
        >
          {{ row.item.acciones.mostrar.label }}
        </b-button>
        <b-button
          v-if="row.item.acciones.editar.show"
          size="sm"
          :variant="row.item.acciones.editar.color"
          class="mr-1"
          @click="editarItem(row.item.id)"
        >
          {{ row.item.acciones.editar.label }}
        </b-button>
        <b-button
          v-if="row.item.acciones.eliminar.show"
          size="sm"
          :variant="row.item.acciones.eliminar.color"
          class="mr-1"
          @click="eliminarItem(row.item.id)"
        >
          {{ row.item.acciones.eliminar.label }}
        </b-button>
      </template>
    </b-table>
    <b-row align-h="between">
      <b-col sm="5" md="4" lg="3" class="my-1">
        <b-form-group
          label="Per page"
          label-for="per-page-select"
          label-cols-sm="6"
          label-cols-md="6"
          label-cols-lg="6"
          label-align-sm="right"
          label-size="sm"
          class="mb-0"
        >
          <b-form-select
            id="per-page-select"
            v-model="filter.perPage"
            :options="pageOptions"
            size="sm"
            @change="searchOrShortOrPage"
          ></b-form-select>
        </b-form-group>
      </b-col>

      <b-col sm="7" md="4" lg="3" class="my-1">
        <b-pagination
          limit="3"
          @input="searchOrShortOrPage"
          v-model="filter.currentPage"
          :total-rows="totalRows"
          :per-page="filter.perPage"
          align="fill"
          size="sm"
          class="my-0"
        ></b-pagination>
      </b-col>
    </b-row>

    <!-- Info modal -->
    <!-- <b-modal
      :id="infoModal.id"
      :title="infoModal.title"
      ok-only
      @hide="resetInfoModal"
    >
      <pre>{{ infoModal.content }}</pre>
    </b-modal> -->
  </div>
</template>
<script>
export default {
  props: {
    items: {
      type: Array,
      require: true,
    },
    title: {
      type: String,
      require: true,
    },
    fields: {
      type: Array,
      require: true,
    },
    filter: {
      type: Object,
      // default: function () {
      //   return { search: "", perPage: 10, sortBy: "id", currentPage: 1 };
      // },
    },
    totalRows: {
      type: Number,
      default: 0,
    },
    keyTable: {
      type: Number,
    },
  },
  data() {
    return {
      currentPage: 1,
      perPage: 10,
      pageOptions: [10, 25, 50, { value: 100, text: "Show a lot" }],
      sortBy: "",
      //   filter: null,
      infoModal: {
        id: "info-modal",
        title: "",
        content: "",
      },
    };
  },
  computed: {
    sortOptions() {
      // Create an options list from our fields
      return this.fields
        .filter((f) => f.sortable)
        .map((f) => {
          return { text: f.label, value: f.key };
        });
    },
  },
  methods: {
    info(item, index, button) {
      this.infoModal.title = `Row index: ${index}`;
      this.infoModal.content = JSON.stringify(item, null, 2);
      this.$root.$emit("bv::show::modal", this.infoModal.id, button);
    },
    resetInfoModal() {
      this.infoModal.title = "";
      this.infoModal.content = "";
    },
    searchOrShortOrPage() {
      console.log("thsi", this.filter);
      this.$emit("searchOrShortOrPage");
    },
    mostarItem(id) {
      this.$emit("mostarItem", id);
    },
    editarItem(id) {
      this.$emit("editarItem", id);
    },
    eliminarItem(id) {
      this.$emit("eliminarItem", id);
    },
  },
};
</script>